/*	imatrix.c	by J-H.AHN	1997	*/
#include <stdio.h>

#define N	4

int gauss_inverse(int n, double *a, double *x);

void main()
{
  static double a[N][N]={ {1,1,1,1}, {1,1,-1,-1}, {1,-1,1,-1}, {1,-1,-1,-1} };
  double x[N][N],t[N][N];
  int i,j,k;

  printf("A matrix :\n");
  for (i=0; i<N; i++) {
    for (j=0; j<N; j++) printf("%lf ",a[i][j]);
    printf("\n");
  }

  gauss_inverse(N,a,x);

  printf("\nInverse matrix :\n");
  for (i=0; i<N; i++) {
    for (j=0; j<N; j++) printf("%lf ",x[i][j]);
    printf("\n");
  }

/*Verify the results */
  for (i=0; i<N; i++) {
    for (j=0; j<N; j++) {
      for (t[i][j]=0,k=0; k<N; k++) {
        t[i][j]+=a[i][k]*x[k][j];
      }
    }
  }
  printf("\nA x X :\n");
  for (i=0; i<N; i++) {
    for (j=0; j<N; j++) printf("%lf ",t[i][j]);
    printf("\n");
  }
}

